//+------------------------------------------------------------------+
//|                            Brooky_Range_Fib_Calc_AutoLine_v1.mq4 |
//|                                         Copyright  2010, Brooky |
//|                               http://forex-indicators.weebly.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010,Brooky"
#property link      "http://forex-indicators.weebly.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 C'155,206,49'
#property indicator_color4 C'224,67,126'
#property indicator_color5 C'130,172,43'
#property indicator_color6 C'192,31,91'
#property indicator_color7 C'80,106,26'
#property indicator_color8 C'134,21,64'
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 1
#property indicator_width4 1
#property indicator_width5 1
#property indicator_width6 1
#property indicator_width7 1
#property indicator_width8 1
#property indicator_style1 2
#property indicator_style2 2
#property indicator_style3 2
#property indicator_style4 2
#property indicator_style5 2
#property indicator_style6 2
#property indicator_style7 2
#property indicator_style8 2


//---- input parameters
extern string    Author_Site = "forex-indicators.weebly.com";
extern string    Calc_Options = "Set Calculation Options";
extern string    Range_Options = "Your Renko Box or Range Bars Size";
extern int       Range_Size =5;
extern string    Count_Options = "Start from Back until Closeby";
extern int       hi_lo_bars_back = 100;
extern int       hi_lo_bars_closeby = 5;
extern string    Size_Options = "May need to change to 0.001 for some Brokers";
extern double    Range_SizeMultiplier =0.0001;
extern string    Fib_Options = "How to show Fibs";
extern bool      show_high_down=false;
extern bool      show_low_up=true;
extern bool      show_short_extension=false;
extern bool      show_long_extension=false;
extern string    Display_Options = "Select Your Display Options";
extern bool      Show_Levels=true;
extern bool      ShowFibComment =false;
extern int       label_backset = 15;
extern color     label_color = Crimson;
extern int       label_size = 10;
extern string    Maximum_Display_Bars = "Shorten for Faster Performance";
extern int       max_bars=5000;

//---- buffers
double low_buff[];
double high_buff[];
double buff_114[];
double buff_236[];
double buff_382[];
double buff_500[];
double buff_618[];
double buff_786[];

//Declare Variables here
bool buysig1 =true;
bool sellsig1 = true;

//Fibo Variables
double fib000 = 0.000;
double fib114 = 0.114;
double fib236 = 0.236;
double fib272 = 0.272;
double fib382 = 0.382;
double fib500 = 0.500;
double fib618 = 0.618;

double fib786 = 0.786;
double fib1 = 1;
double fib100 = 1;
int movement_boxes_counted = 1;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
   
   SetIndexBuffer(0,low_buff);SetIndexStyle(0,DRAW_LINE);SetIndexEmptyValue(0,0.0);
   
   SetIndexBuffer(1,high_buff);SetIndexStyle(1,DRAW_LINE);SetIndexEmptyValue(1,0.0);
   
   SetIndexBuffer(2,buff_114);SetIndexStyle(2,DRAW_LINE);SetIndexEmptyValue(2,0.0);
   
   SetIndexBuffer(3,buff_236);SetIndexStyle(3,DRAW_LINE);SetIndexEmptyValue(3,0.0);
   
   SetIndexBuffer(4,buff_382);SetIndexStyle(4,DRAW_LINE);SetIndexEmptyValue(4,0.0);
   
   SetIndexBuffer(5,buff_500);SetIndexStyle(5,DRAW_LINE);SetIndexEmptyValue(5,0.0);
   
   SetIndexBuffer(6,buff_618);SetIndexStyle(6,DRAW_LINE);SetIndexEmptyValue(6,0.0);
   
   SetIndexBuffer(7,buff_786);SetIndexStyle(7,DRAW_LINE);SetIndexEmptyValue(7,0.0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
   ObjectDelete("fib786Plot_text")  ;
   ObjectDelete("fib618Plot_text")  ;
   ObjectDelete("fib500Plot_text")  ;
   ObjectDelete("fib382Plot_text")  ;
   ObjectDelete("fib236Plot_text")  ;
   ObjectDelete("fib114Plot_text")  ;
   ObjectDelete("fibhighPlot_text")  ;
   ObjectDelete("fibLowPlot_text")  ;
//----   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
    if(counted_bars < 0) 
        return(-1); 

   int limit=Bars-counted_bars; 

   int processBars=MathMin(limit, max_bars); 
 
  for(int i=processBars;i>=0;i--)

         {

             int Hishift=iHighest(NULL,0,MODE_HIGH,hi_lo_bars_back,hi_lo_bars_closeby);//Finds closest High Bar 
             int Loshift=iLowest(NULL,0,MODE_LOW,hi_lo_bars_back,hi_lo_bars_closeby);//Finds closest Low Bar      
              int ShiftDiff = MathAbs (Hishift-Loshift);
             //Find HighBar value
             if(i==Hishift)
                {
                sellsig1 =true;//Triggers hi call
                double Fibo1High = iHigh(NULL,0,Hishift);//The value of the high on the hibar.
                }
             
             //Find Low Bar value
              if(i==Loshift)
                {
                buysig1 =true;//Triggers lo call
                double Fibo1Low = iLow(NULL,0,Loshift);//The value of the low on the Lobar.
                }
             
             //Calc out the fibs
             if(i==Loshift || i==Hishift)//Reckon only on the two points we want.
             {
             
             double Range_SizeDec = Range_Size*Range_SizeMultiplier;//Depends on broker
             double range_counted = (Fibo1High-Fibo1Low)*1.000001;//Force the correct range with a fart off a rounded number
             movement_boxes_counted = range_counted/Range_SizeDec;//How many boxes between points
            
                     //Work out the fib levels - Finds the levels closest to tops and bottoms of the box sizing allocated

                     double Renkofib114 = MathRound(movement_boxes_counted*0.114)/movement_boxes_counted;
                     double Renkofib236 = MathRound(movement_boxes_counted*0.236)/movement_boxes_counted;
                     double Renkofib272 = MathRound(movement_boxes_counted*0.272)/movement_boxes_counted;
                     double Renkofib382 = MathRound(movement_boxes_counted*0.382)/movement_boxes_counted;
                     double Renkofib500 = MathRound(movement_boxes_counted*0.500)/movement_boxes_counted;
                     double Renkofib618 = MathRound(movement_boxes_counted*0.618)/movement_boxes_counted;
                     double Renkofib786 = MathRound(movement_boxes_counted*0.786)/movement_boxes_counted;
                     double Renkofib1 = MathRound(movement_boxes_counted*1.0)/movement_boxes_counted;
   
                    //Assign Fib values from above added to low value.Flip Fibs with options for Top down retrace etc.
                    fib000 = Fibo1Low;
                    fib100 = Fibo1High;
                    fib114 = Fibo1Low + (range_counted * Renkofib114);
                    fib236 = Fibo1Low + (range_counted * Renkofib236);
                    fib272 = Fibo1Low + (range_counted * Renkofib272);
                    fib382 = Fibo1Low + (range_counted * Renkofib382);
                    fib500 = Fibo1Low + (range_counted * Renkofib500);
                    fib618 = Fibo1Low + (range_counted * Renkofib618);
                    fib786 = Fibo1Low + (range_counted * Renkofib786);

                    
                    double range_counted_val=MathAbs(range_counted);
                    double fib114Plot,fib236Plot,fib382Plot,fib500Plot,fib618Plot,fib786Plot;
                    
                    if(show_low_up)
                    {
                    fib114Plot = Fibo1Low+(range_counted_val*Renkofib114);
                    fib236Plot = Fibo1Low+(range_counted_val*Renkofib236);
                    fib382Plot = Fibo1Low+(range_counted_val*Renkofib382);
                    fib500Plot = Fibo1Low+(range_counted_val*Renkofib500);
                    fib618Plot = Fibo1Low+(range_counted_val*Renkofib618);
                    fib786Plot = Fibo1Low+(range_counted_val*Renkofib786);
                    }
                        if(show_high_down)
                    {
                    fib114Plot = Fibo1High-(range_counted_val*Renkofib114);
                    fib236Plot = Fibo1High-(range_counted_val*Renkofib236);
                    fib382Plot = Fibo1High-(range_counted_val*Renkofib382);
                    fib500Plot = Fibo1High-(range_counted_val*Renkofib500);
                    fib618Plot = Fibo1High-(range_counted_val*Renkofib618);
                    fib786Plot = Fibo1High-(range_counted_val*Renkofib786);
                    }
                                            if(show_long_extension)
                    {
                    fib114Plot = Fibo1High+(range_counted_val*Renkofib114);
                    fib236Plot = Fibo1High+(range_counted_val*Renkofib236);
                    fib382Plot = Fibo1High+(range_counted_val*Renkofib382);
                    fib500Plot = Fibo1High+(range_counted_val*Renkofib500);
                    fib618Plot = Fibo1High+(range_counted_val*Renkofib618);
                    fib786Plot = Fibo1High+(range_counted_val*Renkofib786);
                    }                  
                                            if(show_short_extension)
                    {
                    fib114Plot = Fibo1Low-(range_counted_val*Renkofib114);
                    fib236Plot = Fibo1Low-(range_counted_val*Renkofib236);
                    fib382Plot = Fibo1Low-(range_counted_val*Renkofib382);
                    fib500Plot = Fibo1Low-(range_counted_val*Renkofib500);
                    fib618Plot = Fibo1Low-(range_counted_val*Renkofib618);
                    fib786Plot = Fibo1Low-(range_counted_val*Renkofib786);
                    }                    
                    
                    
                    
                  //Show Values as Comment

                  if(ShowFibComment !=false)
                  {
                  string newline = ")\n";
                  Comment("Horizontal Movement in Bars (" ,ShiftDiff,newline,
                  "Vertical Boxes in Movement (" ,movement_boxes_counted,newline,
                  "Pip Range of Movement (" ,range_counted,newline,
                  "--------------------------\n",
                  "Your Range Size (" ,Range_Size,newline,
                  "------\n",
                  "Standard__FIB VALUES_Renko_\n" ,
                  "Fib High (Plot @ " ,Fibo1High,newline,
                  "Fib Low (Plot @ " ,Fibo1Low,newline,
                 
                  "Fib 114 (Plot @ ",Renkofib114,newline,
                  "Fib 236 (Plot @ ",Renkofib236,newline,
                  "Fib 272 (Plot @ ",Renkofib272,newline,
                  "Fib 382 (Plot @ ",Renkofib382,newline,
                  "Fib 500 (Plot @ ",Renkofib500,newline,
                  "Fib 618 (Plot @ ",Renkofib618,newline,
                  "Fib 786 (Plot @ ",Renkofib786,newline,
                  "Fib 1 (Plot @ ",Renkofib1,newline);

                  
                  }
             
            }
             }
             
//Show High n Low
                  for(i=processBars;i>=0;i--)
                  {
              if (buysig1 !=false && Show_Levels!=false) 
              {
              low_buff[i]=Low[Loshift];
              ObjectCreate("fibLowPlot_text", OBJ_TEXT, 0, Time[Loshift], Low[Loshift]);
              ObjectSet("fibLowPlot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fibLowPlot_text", "LOW ", label_size, "Arial", EMPTY);
              }
 
             if (sellsig1 !=false && Show_Levels!=false ) 
             {
             high_buff[i]=High[Hishift];
              ObjectCreate("fibhighPlot_text", OBJ_TEXT, 0, Time[Hishift], High[Hishift]);
              ObjectSet("fibhighPlot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fibhighPlot_text", "HIGH ", label_size, "Arial", EMPTY);
             }
             
//Show Fib levels

              if (Show_Levels!=false)
              {
              buff_114[i]=fib114Plot;
              ObjectCreate("fib114Plot_text", OBJ_TEXT, 0, Time[label_backset], fib114Plot);
              ObjectSet("fib114Plot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fib114Plot_text", "Fib 114 ", label_size, "Arial", EMPTY);
              }
              
              
              if (Show_Levels!=false)
              {
              buff_236[i]=fib236Plot;
              ObjectCreate("fib236Plot_text", OBJ_TEXT, 0, Time[label_backset], fib236Plot);
              ObjectSet("fib236Plot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fib236Plot_text", "Fib 236 ", label_size, "Arial", EMPTY);
              }
                            
              if (Show_Levels!=false)
              {
              buff_382[i]=fib382Plot;
              ObjectCreate("fib382Plot_text", OBJ_TEXT, 0, Time[label_backset], fib382Plot);
              ObjectSet("fib382Plot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fib382Plot_text", "Fib 382 ", label_size, "Arial", EMPTY);
              }
              
              if (Show_Levels!=false)
              {
              buff_500[i]=fib500Plot;
              ObjectCreate("fib500Plot_text", OBJ_TEXT, 0, Time[label_backset], fib500Plot);
              ObjectSet("fib500Plot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fib500Plot_text", "Fib 500 ", label_size, "Arial", EMPTY);
              }
              
              if (Show_Levels!=false)
              {
              buff_618[i]=fib618Plot;
              ObjectCreate("fib618Plot_text", OBJ_TEXT, 0, Time[label_backset], fib618Plot);
              ObjectSet("fib618Plot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fib618Plot_text", "Fib 618 ", label_size, "Arial", EMPTY);
              
              }
               if (Show_Levels!=false)
              {
              buff_786[i]=fib786Plot;
              ObjectCreate("fib786Plot_text", OBJ_TEXT, 0, Time[label_backset], fib786Plot);
              ObjectSet("fib786Plot_text", OBJPROP_COLOR, label_color);
              ObjectSetText("fib786Plot_text", "Fib 786 ", label_size, "Arial", EMPTY);
              }
              
         }

         
   return(0);
  }
//+------------------------------------------------------------------+